<template>
  <div>
    {{ label }}
    <ObInlineSelect
    :is-show-search-prop="false"
    :inherit-width="false"
    :items="preTimeItems"
    v-model="correctTime"
    label="c"
    @search="onSearch"
    ref="timeQA"
  >
    <div slot="default">
      <div class="ob-times">
        <!--
        <div
          class="ob-times__search"
          v-if="isSearch"
        >
          <ObInput
            :value="searchQuery"
            v-debounce:500ms.lock="onSearchTime"
            data-qa="ob-times-search-query"
          />
        </div>
        -->
        <div class="ob-times__list">
          <template v-for="(item, i) in preTimeItems">
            <div
              :key="i"
              class="ob-times__item"
              @click="onChangeTimeItem(item)"
            >{{ item.title }}</div>
            <!--
            <SelectItem
              ref="selectItem"
              :key="item['uuid']"
              :item="item"
              :selected-value="time"
              display-exp="title"
              sub-title-exp="subtitle"
            />
            -->
          </template>
          <div
            class="ob-times__nodata"
            v-if="!preTimeItems.length"
          >Нет данных</div>
        </div>
      </div>
    </div>
  </ObInlineSelect>
  </div>
</template>

<script>
import ObInlineSelect from 'common-components/src/obComponents/obInlineSelect';

export default {
  name: 'timeList',
  components: {
    ObInlineSelect
  },
  props: {
    label: {
      type: String,
      default: ''
    },
    isSearch: {
      type: Boolean,
      default: false
    },
    isAllDay: {
      type: Boolean,
      default: false
    },
    time: {
      type: String,
      default: '00:00+03:00'
    }
  },
  data () {
    return {
      correctTime: '00:00',
      searchQuery: '',
      timeItems: []
    }
  },
  mounted () {
    for (let i = 0; i < 48; i++) {
      this.timeItems.push(this.getTimeItem(i))
    }
  },
  updated() {
    this.correctTime = this.time.split('+')[0]
  },
  computed: {
    preTimeItems () {
      return this.timeItems.filter(item => {
        return item.title.includes(this.searchQuery);
      })
    }
  },
  methods: {
    onSearch(data){
      this.searchQuery = data
    },
    onChangeTimeItem (item) {
      this.timeLocal = item;
      this.$refs.timeQA.select(item);
      this.$emit('change', item);
      this.searchQuery = ''
    },
    getTimeItem (ind) {
      if (ind % 2 === 0) {
        return {
          uuid: ind < 20 ? `0${ind / 2}:00` : `${ind / 2}:00`,
          title: ind < 20 ? `0${ind / 2}:00` : `${ind / 2}:00`
        }
      } else {
        return {
          uuid: ind < 20 ? `0${(ind / 2).toFixed(0) - 1}:30` : `${(ind / 2).toFixed(0) - 1}:30`,
          title: ind < 20 ? `0${(ind / 2).toFixed(0) - 1}:30` : `${(ind / 2).toFixed(0) - 1}:30`
        }
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.ob-times {
  padding: 20px 0;

  &__item {
    font-size: 16px;
    padding: 8px 20px;
    &:hover {
      cursor: pointer;
      background-color: $blue-blue-hoarfrost;
    }
  }
  &__search {
    margin: 0 20px 18px;
  }
  &__list {
    /deep/ .select-item button {
      padding-right: 20px;
      padding-left: 20px;
    }
  }
  &__nodata {
    font-size: 14px;
    padding: 0 20px;
  }
}
</style>
